
;;; this is a standard COM program.
[BITS 16]
[ORG 0x100]

;;; change this to int 21 when we fix nt-lfn.asm to hook that
%define lfnInt int 0x21
%define newline call justCRLF        
[section .text]
        
        mov dx,welcome          ;
        call printstr           ;

        ;; really test to see if installed here - this is bogus
        mov dx,foundOK
        call printstr
        
        ;; now excersize it
        jmp test7160
        
test7139:       
;;; test 0x7139 Make Directory
        newline
        newline
        mov dx, test7139str
        call printstr
        mov dx, test7139dir
        mov ax, 0x7139          ;
        lfnInt
        jc L7139error
        mov dx, test7139success
        call printstr
        jmp test713B
L7139error:
        mov dx, test7139error
        call printstr
        jmp test7147


        
test713B:  
;;; Test 0x713B Change Directory
        newline
        newline
        mov dx, test713Bstr
        call printstr
        mov dx, test7139dir
        mov ax, 0x713B
        lfnInt
        jc L713Berror
        mov dx, test713Bsuccess
        call printstr
        mov dx, test713BoldDir
        mov ax, 0x713B
        lfnInt
        jmp test713A

L713Berror:
        mov dx, test713Berror
        call printstr

test713A:
;;; remove Directory
        newline
        newline
        mov dx, test713Astr
        call printstr
        mov dx, test7139dir
        mov ax, 0x713A          ;
        lfnInt
        jc L713Aerror
        mov dx, test713Asuccess
        call printstr
        jmp test7147
L713Aerror:
        mov dx, test713Aerror
        call printstr
        jmp test7147
 
test7147:
;;; Get Current Directory
        newline
        newline
        mov dx, test7147str
        call printstr
        mov dl, 0               ; select current drive
        mov si, test7147buf     ; assume DS is OK
        mov ax, 0x7147
        lfnInt
        jc L7147error
        mov dx,si
        call printstr           ; print out what we got
        mov dl,20
        mov si, test7147buf
        mov ax, 0x7147
        lfnInt
        jc L7147error
        mov dx,si
        call printstr

        
        mov dx, test7147success
        call printstr
        jmp test7160
L7147error:
        mov dx, test7147error
        call printstr
        jmp test7160            ; 
               
        
test7160:
        ;; test 0x7160 is a 3 parter
        newline
        newline
        mov dx, test7160str
        call printstr
        
        newline
        mov dx, test7160_0str   
        call printstr
        mov dx, truenameTest    ;
        call printstrAddCRLF
        mov ax, 0x7160          ;
        mov cl, 0x0             ;
        mov ch, 0x0             ; 
        mov si, truenameTest    ; 
        mov di, convertName
        stc
        lfnInt                  ; 
        jnc L1                  ;
        mov dx, lfnError        ;
        call printstr           ;
        jmp L2                  ; 
L1:     
        ;; print out what it gave us
        mov dx, di
        call printstrAddCRLF
        mov dx, lfnSuccess      ; 
        call printstr 
L2:

        jmp theEnd
        newline
        mov dx, test7160_1str
        call printstr
        mov dx, fileName        ;
        call printstrAddCRLF    ; 
        mov ax, 0x7160          ;
        mov cl, 0x1             ;
        mov ch, 0x0             ; 
        mov si, fileName
        mov di, convertName
        lfnInt                  ; 
        jnc L3
        mov dx, lfnError
        call printstr           ;
        jmp L4
L3:     
        ;; print out what it gave us
        mov dx, di
        call printstrAddCRLF
        mov dx, lfnSuccess      ; 
        call printstr
L4:
        newline
        mov dx, test7160_2str
        call printstr
        mov ax, 0x7160          ;
        mov cl, 0x2             ;
        mov ch, 0x0             ; 
        mov si, fileName
        mov di, convertName
        lfnInt                  ; 
        jnc L5                  ;
        mov dx, lfnErrorOK      ;
        call printstr           ;
        jmp test716C
L5:     
        ;; print out what it gave us
        mov dx, di
        call printstrAddCRLF
        mov dx, lfnSuccess      ; 
        call printstr

        
test716C:
;;; create or open file
        newline
        newline
        mov dx, test716Cstr
        call printstr
        
        mov ax, 0x716C          ; create/open 
        mov dx, 0x0001          ; action open file
        mov si, fileName        ; file to open
        lfnInt                  ;
        jc L716Cerror
        mov [fileHandle],ax
        mov dx, test716Csuccess
        call printstr

        
        jmp test5704            ; 
L716Cerror:
        mov dx, test716Cerror
        call printstr
        jmp theEnd        

        
test5704:
        newline
        newline
        mov dx, test5704str
        call printstr
        mov bx, [fileHandle]
        mov ax, 0x5704
        lfnInt
        jc L5704error
        mov dx, test5704success
        call printstr
        jmp test5706
L5704error:
        mov dx, test5704error
        call printstr
        jmp theEnd

test5706:
        newline
        newline
        mov dx, test5706str
        call printstr
        mov bx, [fileHandle]
        mov ax, 0x5706
        lfnInt
        jc L5706error
        mov dx, test5706success
        call printstr
        jmp test71A6
L5706error:
        mov dx, test5706error
        call printstr
        
test71A6:
        newline
        newline
        mov dx, test71A6str
        call printstr
        mov dx,fileInfoBuf
        mov bx, [fileHandle]
        mov ax, 0x71A6
        lfnInt                  ;
        jc L71A6error
        mov dx, test71A6success
        call printstr
        jmp test71A0
L71A6error:
        mov dx, test71A6error
        call printstr
        
test71A0:
;;; 0x71A0 - GetVolumeInformation
        newline
        newline
        mov dx, test71A0str
        call printstr
        mov di,ds               ; just in case es has been trashed
        mov es,di
        mov di, test71A0buf1
        mov dx, test71A0buf2
        mov cx, 255
        mov ax, 0x71A0          ; GetVolumeInfo
        stc
        lfnInt
        jc L71A0error
        mov dx, test71A0success
        call printstr
        jmp theEnd              ; 

L71A0error:
        mov dx, test71A0error
        call printstr

        
test714E:
;;; Find First
        newline
        newline
        mov dx, test714Estr
        call printstr

        mov dx, fileName
        mov di, findData
        mov cx, 0
        mov si, 0
        mov ax, 0x714E
        lfnInt
        jc L714Eerror
        mov dx, test714Esuccess
        call printstr
        jmp test714F
L714Eerror:
        mov dx, test714Eerror
        call printstr
test714F:
;;; Find Next
test71A1:
;;; Find Close

        

        
theEnd:
        newline
        newline
        mov dx, byebye
        call printstr
        mov ax,0x4c00		; quit  
	int 0x21                ; invoke dos

;;; print out a $ terminated string by invoking DOS.
;;; dx holds pointer to string
printstr :     
	mov ah,9                ; select DOS print string function
	int 0x21                ; invoke dos
        ret
printstrAddCRLF:
        mov ah,9
        int 0x21
justCRLF:       
        mov dx, crlf
        mov ah,9
        int 0x21
        ret
        

[section .data]
        welcome db 'LFNTEST Program - Will excercise all of the Win 95 LFN calls',13,10,'$'
        byebye db 'LFNTEST Program - Done testing',13,10,'$'
        
        test5704str db 'Testing LFN Func 0x5704 Get Last Access ',13,10,'$'; 
        test5704success db '0x5704 Worked!!!',13,10,'$'
        test5704error db 'Could not get last access date',13,10,'$'

        test5706str db 'Testing LFN Func 0x5706 Get Creation Date/Time ',13,10,'$'; 
        test5706success db '0x5706 Worked!!!',13,10,'$'
        test5706error db 'Could not get creation date',13,10,'$'
        
        test7139str db 'Testing 0x7139 (Make Directory) to see if it works',13,10,'$'
        test7139dir db 'long_foo_bar',0;
        test7139error db 'Make Directory Failed !!!!',13,10,'$'
        test7139success db 'Make Directory PASSED',13,10,'$'
        test713Bstr db 'Testing 0x713b (Change Directory) to newly created directory',13,10,'$'
        test713Berror db 'Could not Change Directory!',13,10,'$'
        test713Bsuccess db 'Change Directory OK',13,10,'$'
        test713BoldDir db '..',0
        test713Astr db 'Testing 0x713A (Remove Directory)',13,10,'$'
        test713Asuccess db 'Removed Directory OK',13,10,'$'
        test713Aerror db 'Could not remove Directory !!!!'

        test7147str db 'Testing 0x7147 (Get Current Directory)',13,10,'$'
        test7147buf db '                                                     ',13,10,'$'
        test7147success db 'Got the Current Directory OK',13,10,'$'
        test7147error db 'Could not get Current Directory',13,10,'$'

        test714Estr db 'Testing 0x714E Find First File',13,10,'$'
        test714Esuccess db 'Find First File PASSED',13,10,'$'
        test714Eerror db 'Could not find first file !!',13,10,'$'        
                
        test7160str  db 'Testing LFN Func 0x7160 to see if it works',13,10,'$' ;
        test7160_0str db 'Testing CL = 0x0',13,10,'$'
        test7160_1str db 'Testing CL = 0x1',13,10,'$'
        test7160_2str db 'Testing CL = 0x2',13,10,'$'

        test716Cstr db 'Testing LFN Func 0x716C (Create/Open FIle)',13,10,'$'
        test716Csuccess db 'Opened File OK',13,10,'$'
        test716Cerror db 'Could not Open File',13,10,'$'
                
        test71A0str db 'Testing - 0x71A0 (Get Volume Info)',13,10,'$'
        test71A0buf1 db '                                                       ',13,10,'$'
        test71A0buf2 db 'T:\',0,13,10,'$'
        test71A0success db 'Got Volume Info',13,10,'$'
        test71A0error db 'Could not get volume info',13,10,'$'

        test71A6str db 'Testing 0x71A6 Get File Info By Handle',13,10,'$'
        test71A6error db 'Could not get File info!!!',13,10,'$'
        test71A6success db 'Got File Info OK',13,10,'$'
                
        lfnSuccess db 'Hey it f-ing worked',13,10,'$'
        lfnError db 'Damn - LFN Error Occurred',13,10,'$'
        lfnErrorOK db 'Error Occurred, but we expected it to',13,10,'$'
        notFound db 'No entry in interrupt table.  Run nt-lfn.com first',13,10,'$'
        wrongVersionStr db ' CF set - Old LFN or interrupt used by something else!',13,10,'$'
        foundOK db 'nt-lfn appears to be installed correctly',13,10,'$'
        crlf db 13,10,'$'        
        fileName db 'C:/andrewc_top/first.txt',0,'$',0;
        truenameTest db 'c:/dev/con','$',0; 
        convertName db '                                    ','$';
        endConvertName  db 0    ;
        fileHandle dw 0         ;
        findHandle dw 0         ;
findData: times 0x13E db 9
        ;; should use res or something here
        fileInfoBuf db '                                                                    '
        fileReadBuf:    times 0x13E  db 9










